<cfcomponent output="false" displayname="CKFinder" hint="Create an instance of the CKFinder.">
<!---
 * CKFinder
 * ========
 * http://www.ckfinder.com
 * Copyright (C) 2007-2008 Frederico Caldeira Knabben (FredCK.com)
 *
 * The software, this file and its contents are subject to the CKFinder
 * License. Please read the license.txt file before using, installing, copying,
 * modifying or distribute this file or part of its contents. The contents of
 * this file is part of the Source Code of CKFinder.
--->

<cfset this.defaultPath = "/ckfinder/">
<cfset Init()>

<cffunction
	name="Init"
>
	<cfparam name="this.basePath" type="string" default="#this.defaultPath#"/>
	<cfparam name="this.width" type="string" default="100%" />
	<cfparam name="this.height" type="string" default="400" />
	<cfparam name="this.selectFunction" type="string" default="" />
	<cfparam name="this.className" type="string" default="" />
</cffunction>

<cffunction
	name="Create"
	access="public"
	output="true"
	returntype="void"
	hint="Renders CKFinder in the current page"
>
	<cfoutput>#CreateHtml()#</cfoutput>
</cffunction>

<cffunction
	name="CreateHtml"
	access="public"
	output="false"
	returntype="string"
	hint="Gets the HTML needed to create a CKFinder instance"
>
	<cfset var str = "" >
	<cfset var class= "" >

	<cfif len( this.className ) gt 0>
		<cfset class = " class=""" & this.className & """">
	</cfif>

	<cfreturn "<iframe src=""" & _BuildUrl() & """ width=""" & this.width & """ " & "height="""
		& this.height & """" & this.className & """ frameborder=""0"" scrolling=""no""></iframe>">

</cffunction>

<cffunction
	name="_BuildUrl"
	access="private"
	output="false"
	returnType="string"
	hint="Build URL to CKFinder"
>
	<cfset var url = this.basePath>
	<cfif not Len(url)>
		<cfset url = this.defaultPath >
	</cfif>
	<cfif Right(url, 1) neq "/">
		<cfset url = url & "/" >
	</cfif>
	<cfset url = url & "ckfinder.html">
	<cfif Len(this.selectFunction)>
		<cfset url = url & '?action=js&amp;func=' & this.selectFunction >
	</cfif>
	<cfreturn url>
</cffunction>

<cffunction
	name="SetupFCKeditor"
	access="public"
	output="false"
	returnType="void"
	hint="Setup FCKeditor"
>
	<cfset var url = "" >
	<cfset var dir = "" >

	<cfparam name="this.editorObj" />
	<cfparam name="this.basePath" type="string" default="#this.defaultPath#"/>
	<cfparam name="this.imageType" type="string" default="" />
	<cfparam name="this.flashType" type="string" default="" />

	<cfif not Len(this.basePath)>
		<cfset this.basePath = this.defaultPath>
	</cfif>
	<cfif Left(this.basePath, 1) neq "/">
		<cfset this.basePath = mid(CGI.SCRIPT_NAME, 1, Len(CGI.SCRIPT_NAME) - Find("/", Reverse(CGI.SCRIPT_NAME))) & this.basePath>
	</cfif>

	<cfset url = _BuildUrl()>
	<cfset this.editorObj.config['LinkBrowserURL'] = url>
	<cfset this.editorObj.config['ImageBrowserURL'] = url & urlencodedformat('?type=' & iif( Len( this.imageType ), this.imageType, De('Images')))>
	<cfset this.editorObj.config['FlashBrowserURL'] = url & urlencodedformat('?type=' & iif( Len( this.flashType ), this.flashType, De('Flash')))>
	<cfset dir = GetDirectoryFromPath(url) >
	<cfset this.editorObj.config['LinkUploadURL'] = urlencodedformat(dir & 'core/connector/cfm/connector.cfm?command=QuickUpload&type=Files')>
	<cfset this.editorObj.config['ImageUploadURL'] = urlencodedformat(dir & 'core/connector/cfm/connector.cfm?command=QuickUpload&type=' & iif( Len( this.imageType ), this.imageType, De('Images')))>
	<cfset this.editorObj.config['FlashUploadURL'] = urlencodedformat(dir & 'core/connector/cfm/connector.cfm?command=QuickUpload&type=' & iif( Len( this.flashType ), this.flashType, De('Flash')))>
</cffunction>

</cfcomponent>
